/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package klaverjassen;

/**
 *
 * @author Joris & Wolter
 */
public class Tafel {

    private Kaart[][] slagen = new Kaart[8][4];
    private int huidigeSlag;
    private int huidigeKaart;
    private int laatsteSpeler;
    private int[] startspelers;
    private int[] slagWinnaars;
    private int troef;
    private int speelt;
    private int slagKleur;
    private int kaartTeller;

    public Tafel() {
        for (int i = 0; i < 8; i++) {
            for (int j = 0; j < 4; j++) {
                slagen[i][j] = new Kaart();
            }
        }
        huidigeSlag = 0;
        huidigeKaart = 0;
        kaartTeller = 0;
        startspelers = new int[8];
        slagWinnaars = new int[8];
    }

    public void reset() {
        for (int i = 0; i < 8; i++) {
            for (int j = 0; j < 4; j++) {
                slagen[i][j] = new Kaart();
            }
        }
        huidigeSlag = 0;
        huidigeKaart = 0;
        kaartTeller = 0;
        startspelers = new int[8];
        slagWinnaars = new int[8];
    }

    public Kaart[] getSlag(int i) {
        // Spelers kunnen een bepaalde slag opvragen
        Kaart[] slag = new Kaart[4];
        System.arraycopy(slagen[i], 0, slag, 0, 4);
        return slag;
    }

    public void speelKaart(Kaart kaart, int id) {
        kaartTeller++;
        slagen[huidigeSlag][id] = kaart;
        laatsteSpeler = id;

        if (kaart.getPositie() == 1337) {
            System.out.println("Er wordt nu een foute kaart gespeeld." + kaartTeller);
        }
        //Zet huidigeKaart en Slag goed voor de volgende speler
        huidigeKaart = (huidigeKaart + 1) % 4;
        if (huidigeKaart == 0 && huidigeSlag != 7) {
            // de volgende startspeler is de winnaar van de huidige slag
            int winnaar = slagWinnaar();
            huidigeSlag++;
            startspelers[huidigeSlag] = winnaar;
            Klaverjassen.spelers[winnaar].setTurn();
        } else if (kaartTeller == 32) {
            //alle kaarten zijn getelt, verwerk laatste slag en luidt het einde van de ronde
            slagWinnaar();
            Klaverjassen.setEindeRonde();
        } else {
            //slag is niet nieuw, volgende speler is
            Klaverjassen.spelers[((id + 1) % 4)].setTurn();
        }

        for (int i = 0; i < 4; i++) {
            synchronized (Klaverjassen.spelers[i]) {
                if (i != id) {
                    Klaverjassen.spelers[i].notify();
                }
            }
        }
    }

    public int getCurrentSlag() {
        return huidigeSlag;
    }

    public Kaart getLaatsteKaart() {
        if (huidigeKaart != 0) {
            return slagen[huidigeSlag][laatsteSpeler];
        } else {
            return null;
        }
    }

    public int getStartspeler(int i) {
        return startspelers[i];
    }

    public int getStartspeler() {
        return startspelers[huidigeSlag];
    }

    public void setStartspeler(int speler) {
        startspelers[huidigeSlag] = speler;
    }

    public void setTroef(int troef) {
        this.troef = troef;
        System.out.println("troef: " + troef);
    }

    public int getTroef() {
        return troef;
    }

    void setSpeelt(int speler) {
        this.speelt = speler;
    }

    int getSpeelt() {
        return this.speelt;
    }

    public void setSlagKleur(int kleur) {
        this.slagKleur = kleur;
    }

    public int getSlagKleur() {
        return slagKleur;
    }

    public int getHoogte(int positie, int kleur) {
        // gegeven een positie in een array, return de hoogte in de rangorde der kaarten.
        if (positie == -1) {
            return -1;
        }
        if (positie == 1337) {
            return 1337;
        }
        if (kleur == troef) {
            if (positie == 0 || positie == 1) {
                //7 en 8 zijn laagsten             
                return positie;
            }
            if (positie == 5) {
                //vrouw
                return 2;
            }
            if (positie == 6) {
                //heer
                return 3;
            }
            if (positie == 3) {
                //10
                return 4;
            }
            if (positie == 7) {
                //Aas
                return 5;
            }
            if (positie == 2) {
                //Nel
                return 6;
            }
            if (positie == 4) {
                //Boer
                return 7;
            }
        } else {
            if (positie == 0 || positie == 1 || positie == 2 || positie == 7) {
                //7,8,9, Aas
                return positie;
            }
            if (positie == 3) {
                //tien
                return 6;
            }
            if (positie == 4 || positie == 5 || positie == 6) {
                //Boer,Vrouw,Heer
                return positie - 1;
            }
        }
        return 0;
    }

    public int getPositie(int hoogte, int kleur) {
        if (kleur == troef) {
            if (hoogte == 0 || hoogte == 1) {
                //7,8
                return hoogte;
            }
            if (hoogte == 7) {
                //Boer
                return 4;
            }
            if (hoogte == 6) {
                //Nel
                return 2;
            }
            if (hoogte == 4) {
                //tien
                return 3;
            }
            if (hoogte == 5) {
                //Aas
                return 7;
            }
            if (hoogte == 2 || hoogte == 3) {
                //vrouw, heer
                return hoogte + 3;
            }
        } else {
            if (hoogte == 0 || hoogte == 1 || hoogte == 2 || hoogte == 7) {
                //7,8,9,Aas
                return hoogte;
            }
            if (hoogte == 6) {
                //10
                return 3;
            }
            if (hoogte == 3 || hoogte == 4 || hoogte == 5) {
                //boer,vrouw,aas
                return hoogte + 1;
            }
        }
        return 1337;
    }

    public int getLagere(int positie, int kleur) {
        if (kleur == troef) {
            if (positie == 4) {
                //Boer->nel
                return 2;
            }
            if (positie == 2) {
                //nel->aas
                return 7;
            }
            if (positie == 7) {
                //aas->tien
                return 3;
            }
            if (positie == 3) {
                //toen->heer
                return 6;
            }
            if (positie == 6) {
                //heer->vrouw
                return 5;
            }
            if (positie == 5) {
                //vrouw->8
                return 1;
            }
            if (positie == 1) {
                //8->7
                return 0;
            }
        } else {
            if (positie == 7) {
                //Aas->10
                return 3;
            }
            if (positie == 3) {
                //10->H
                return 6;
            }
            if (positie == 6 || positie == 5 || positie == 2 || positie == 1) {
                //H->V V->B 9->8 8->7
                return positie - 1;
            }
            if (positie == 4) {
                //B->9
                return 2;
            }
        }
        return 1337;
    }

    private int slagWinnaar() {
        int startspeler = startspelers[huidigeSlag];
        //Startspeler heeft in eerst instantie gewonnen
        int winnaar = startspeler;
        int hoogsteKaart = slagen[huidigeSlag][startspeler].getPositie();
        int kleur = slagen[huidigeSlag][startspeler].getKleur();

        int huidigeSpeler = (startspeler + 1) % 4;
        do {
            if (slagen[huidigeSlag][huidigeSpeler].getKleur() == kleur
                    && getHoogte(hoogsteKaart, kleur) < getHoogte((slagen[huidigeSlag][huidigeSpeler].getPositie()), kleur)) {
                //zelfde kleur en hoger
                hoogsteKaart = slagen[huidigeSlag][huidigeSpeler].getPositie();
                winnaar = huidigeSpeler;
            } else if (slagen[huidigeSlag][huidigeSpeler].getKleur() == troef && kleur != troef) {
                // ingetroefd
                kleur = troef;
                hoogsteKaart = slagen[huidigeSlag][huidigeSpeler].getPositie();

                winnaar = huidigeSpeler;
            } //anders doe niks, je hebt lager gespeeld.
            
            huidigeSpeler = (huidigeSpeler + 1) % 4;
        } while (huidigeSpeler != startspeler);
        slagWinnaars[huidigeSlag] = winnaar;
        System.out.println("En de winnaar is: " + winnaar);
        return winnaar;
    }

    public int slagLigtAan() {
        int startspeler = startspelers[huidigeSlag];
        int huidigeSpeler = (startspeler + 1) % 4;
        int hudigeWinnaar = startspeler;

        int hoogsteKaart = slagen[huidigeSlag][startspeler].getPositie();
        int kleur = slagen[huidigeSlag][startspeler].getKleur();

        do {
            if (slagen[huidigeSlag][huidigeSpeler].getKleur() == kleur
                    && hoogsteKaart < getHoogte((slagen[huidigeSlag][huidigeSpeler].getPositie() - 7), kleur)) {
                //zelfde kleur
                hoogsteKaart = slagen[huidigeSlag][huidigeSpeler].getPositie() - 7;
                hudigeWinnaar = huidigeSpeler;
            } else if (slagen[huidigeSlag][huidigeSpeler].getKleur() == troef) {
                // getroefd
                kleur = troef;
                hoogsteKaart = slagen[huidigeSlag][huidigeSpeler].getPositie() - 7;
                hudigeWinnaar = huidigeSpeler;
            }
            huidigeSpeler = (huidigeSpeler + 1) % 4;
        } while (huidigeSpeler != startspeler && slagen[huidigeSlag][huidigeSpeler].getPositie() != -1);

        return hudigeWinnaar;
    }

    public Kaart[][] getSlagen() {
        return slagen;
    }

    public int[] getWinnaars() {
        return slagWinnaars;
    }
    public int getAantalKaartenInSlag(){
        int teller = 0;
        for (int i = 0; i < 4; i++) {
            if(slagen[huidigeSlag][i].getPositie() != -1 || slagen[huidigeSlag][i].getPositie() != 1337){
                teller++;
            }
        }
        return teller;
    }
}
